// This is a simple example
package main

import (
	"go.wit.com/log"

	"go.wit.com/lib/gui/repostatus"
)

func (r *repo) newScan() bool {
	if r.status == nil {
		log.Warn("repo.status = nil. not initialized for some reason")
		return false
	}
	// r.scan()
	if repostatus.VerifyLocalGoRepo(r.getPath()) {
		log.Verbose("repo actually exists", r.getPath())
	} else {
		log.Warn("repo does not exist", r.getPath())
		return false
	}
	mname := r.status.GetMasterBranchName()
	mver := r.status.GetMasterVersion()
	if mname != "guimaster" {
		mver = mver + " (" + mname + ")"
	}
	r.masterVersion.SetLabel(mver)

	dname := r.status.GetDevelBranchName()
	dver := r.status.GetDevelVersion()
	if dname != "devel" {
		dver = dver + " (" + dname + ")"
	}
	r.develVersion.SetLabel(dver)

	uname := r.status.GetUserBranchName()
	uver := r.status.GetUserVersion()
	if uname != "jcarr" {
		uver = uver + " (" + uname + ")"
	}
	r.userVersion.SetLabel(uver)

	cbname := r.status.GetCurrentBranchName()
	cbversion := r.status.GetCurrentBranchVersion()
	lasttag := r.status.GetLastTagVersion()
	r.lastTag.SetLabel(lasttag)
	r.vLabel.SetLabel(cbname + " " + cbversion)

	if r.status.Changed() {
		log.Warn("should scan here")
	}
	status := r.status.GetStatus()
	r.dirtyLabel.SetLabel(status)
	if status == "PERFECT" {
		if me.autoHidePerfect.Checked() {
			r.Hide()
		}
		return true
	}
	return false
}

func (r *repo) getStatus() string {
	if r.status.CheckDirty() {
		log.Warn("CheckDirty() true")
		return "dirty"
	}

	if r.status.CheckBranches() {
		log.Warn("Branches are Perfect")
		return "PERFECT"
	}
	log.Warn("Branches are not Perfect")
	return "merge"
}
